class String

  def scan_datetime(flag=2)
    datetime_re=/((\d\d)\/(\d\d)\/(\d\d) (\d\d):(\d\d):(\d\d))/

    month_re=/(0?[1-9]|1[0-2])/             
    # 01 to 09 or 1 to 9 or 10-12
    day_re=/([0-2]?[1-9]|[1-3][01])/        
    # 1-9 or 01-09 or 11-19 or 21-29 or 10,11,20,21,30,31
    year_re=/(\d\d)/                        
    # 00-99
    hour_re=/([01]?[1-9]|[12][0-4])/        
    # 1-9 or 00-09 or 11-19 or 10-14 or 20-24
    minute_re=/([0-5]\d)/                   
    # 00-59, both digit required
    second_re=/(:[0-6]\d)?/                 
    # leap seconds ;-) both digits required if present

    date_re=/(#{month_re.source}\/#{day_re.source}\/#{year_re.source})/
    time_re=/(#{hour_re.source}:#{minute_re.source}#{second_re.source})/
       
    datetime_re2 = /(#{date_re.source} #{time_re.source})/

    if flag==2
      self.scan(datetime_re2)  # returns arrays
    else
      self.scan(datetime_re)
    end
  end
end


str="Recorded on 11/18/00 20:31:00, viewed 11/18/00 8:31 PM "
str.scan_datetime 
# [ ["11/18/00 20:31:00", "11", "18", "00", "20", "31", "00"] ]
str.scan_datetime(2)
# [ ["11/18/00 20:31:00", "11/18/00", "11", "18", "00", 
#  "20:31:00", "20", "31", ":00"], 
# ["11/18/00 8:31", "11/18/00", "11", "18", "00", "8:31", 
#  "8", "31", nil]  ]
 
