def paren_match str
  stack = Stack.new
  lsym = "{[(<"
  rsym = "}])>"
  str.each_byte do |byte| 
    sym = byte.chr
    if lsym.include? sym
      stack.push(sym)
    elsif rsym.include? sym
      top = stack.peek
      if lsym.index(top) != rsym.index(sym)
        return false 
      else
        stack.pop
      end
      # Ignore non-grouped characters...
    end
  end
  # Ensure stack is empty...
  return stack.empty?
end

str1 = "Hello (yes, [um] you) there!"
str2 = "(((a+b))*((c-d)-(e*f))"
str3 = "[[(a-(b-c))], [[x,y]]]"
    
paren_match str1          # true
paren_match str2          # false
paren_match str3          # true
