require "gtk"

class TextWindow < Gtk::Window

  def initialize
    super
    set_title("Ruby/GTK Text Sample")
    signal_connect("destroy") { Gtk::main_quit }

    @text = Gtk::Text.new
    @text.signal_connect("changed") { onChanged }
    @text.set_word_wrap(true)
    @text.set_editable(true)

    font = Gdk::Font::font_load("times")
    style = @text.get_style
    style.set_font(font)

    @status = Gtk::Label.new("")

    scroller = Gtk::ScrolledWindow.new
    scroller.set_policy(Gtk::POLICY_NEVER, 
          Gtk::POLICY_AUTOMATIC)
    scroller.add(@text)

    box = Gtk::VBox.new
    box.add(scroller)
    box.add(@status)
    add(box)

    @text.insert_text("This is an editor", 0)
    @text.insert_text("really ", 5)

    show_all
  end

  def onChanged
    text = "Length: " + @text.get_length.to_s
    @status.set_text(text)
  end

end

TextWindow.new
Gtk::main
