def delete_all(dir)
  threads = []
  Dir.foreach(dir) do |e|
    # Don't bother with . and ..
    next if [".",".."].include? e
    fullname = dir + File::Separator + e
    if FileTest::directory?(fullname)
      threads << Thread.new(fullname) do |fn|
        delete_all(fn)
      end
    else
      File.delete(fullname)
    end
  end
  threads.each { |t| t.join }
  Dir.delete(dir)
end

delete_all("/tmp/stuff")
