$filepath = "/tmp/messagestore.dat"

class Message
  attr_accessor :id, :title, :sender, :replies, :date, :body
  def initialize(title, sender)
    @title = title
    @sender = sender
    @date = Time.now
    @replies = Array.new
  end
  def add_reply(message)
    @replies.push message
  end
end

class MessageStore
  attr_accessor :messages, :filepath, :id, :message_table

  def MessageStore.load(filepath)
    if !FileTest.exist?(filepath)
      welcomemsg = Message.new("Welcome to RuBoard", "chad")
      welcomemsg.body = "Please enjoy your stay!"
      mstore = MessageStore.new
      mstore.add_message(welcomemsg)
      f = File.new(filepath, "w")
      Marshal.dump(mstore, f)
      f.close
    end
    file = File.open(filepath, "r")
    Marshal.load(file)
  end

  def save(filepath)
    File.delete(filepath)
    Marshal.dump(self, File.new(filepath, "w"))
  end
  
  def initialize
    @message_table = Hash.new
    @id = 0
    @messages = Array.new
  end

  def add_message(message)
    message.id = next_id
    @message_table[message.id] = message
    @messages.push message
  end
  
  def get_message(num)
    @message_table[num]
  end

  private
  def next_id
    @id += 1
  end

end


# Auxiliary methods...

def get_message_view(message)
  template = "<i>Message %%NUM%%</i><BR>
  <i>From: %%SENDER%%</i><BR>
  <i>Date: %%DATE%%</i><BR>
  <i>Title: %%TITLE%%</i><BR>
  <HR>
  %%BODY%%    
  <HR>"
  template.gsub!(/%%NUM%%/, message.id.to_s)
  template.gsub!(/%%SENDER%%/, message.sender)
  template.gsub!(/%%DATE%%/, message.date.to_s)
  template.gsub!(/%%TITLE%%/, message.title)
  template.gsub!(/%%BODY%%/, message.body)
  template
end

def get_messages
  mstore = get_message_store 
  mstore.messages
end    

def get_message_store
  MessageStore.load($filepath)
end
